<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑旧运动时卡' : '添加旧运动时卡'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="卡类型" name="cardType">
        <a-input
          allow-clear
          placeholder="请输入卡类型"
          v-model:value="form.cardType"
        />
      </a-form-item>
      <a-form-item label="卡号" name="cardNum">
        <a-input
          allow-clear
          placeholder="请输入卡号"
          v-model:value="form.cardNum"
        />
      </a-form-item>
      <a-form-item label="姓名" name="username">
        <a-input
          allow-clear
          placeholder="请输入姓名"
          v-model:value="form.username"
        />
      </a-form-item>
      <a-form-item label="联系电话" name="phone">
        <a-input
          allow-clear
          placeholder="请输入联系电话"
          v-model:value="form.phone"
        />
      </a-form-item>
      <a-form-item label="卡内余额" name="remainingMoney">
        <a-input
          allow-clear
          placeholder="请输入卡内余额"
          v-model:value="form.remainingMoney"
        />
      </a-form-item>
      <a-form-item label="卡内次数" name="remainingNum">
        <a-input
          allow-clear
          placeholder="请输入卡内次数"
          v-model:value="form.remainingNum"
        />
      </a-form-item>
      <a-form-item label="剩余天数" name="remainingDay">
        <a-input
          allow-clear
          placeholder="请输入剩余天数"
          v-model:value="form.remainingDay"
        />
      </a-form-item>
      <a-form-item label="截止日期" name="expireDate">
        <a-input
          allow-clear
          placeholder="请输入截止日期"
          v-model:value="form.expireDate"
        />
      </a-form-item>
      <a-form-item label="创建日期" name="createDate">
        <a-input
          allow-clear
          placeholder="请输入创建日期"
          v-model:value="form.createDate"
        />
      </a-form-item>
      <a-form-item label="操作员" name="operateUser">
        <a-input
          allow-clear
          placeholder="请输入操作员"
          v-model:value="form.operateUser"
        />
      </a-form-item>
      <a-form-item label="状态" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkOldCard, updateThinkOldCard } from '@/api/think/thinkOldCard';
  import { ThinkOldCard } from '@/api/think/thinkOldCard/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkOldCard | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkOldCard>({
    id: undefined,
    cardType: undefined,
    cardNum: undefined,
    username: undefined,
    phone: undefined,
    remainingMoney: undefined,
    remainingNum: undefined,
    remainingDay: undefined,
    expireDate: undefined,
    createDate: undefined,
    operateUser: undefined,
    status: undefined,
    thinkOldCardId: undefined,
    thinkOldCardName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkOldCardName: [
      {
        required: true,
        type: 'string',
        message: '请填写旧运动时卡名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkOldCard : addThinkOldCard;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
